﻿using System;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Threading;

//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================

namespace WpfCustomGraphics
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        // Таймер счетчика.
        readonly DispatcherTimer dispatcherTimer;

        public MainWindow()
        {
            InitializeComponent();

            // Инициализация и запуск таймера.
            dispatcherTimer = new System.Windows.Threading.DispatcherTimer();
            dispatcherTimer.Tick += DispatcherTimer_Tick; ;
            dispatcherTimer.Interval = new TimeSpan(0, 0, 0, 0, 200);
        }


        int count = 0;
        private void DispatcherTimer_Tick(object? sender, EventArgs e)
        {
            // Разряд - десятки
            int pos1 = count / 10;
            // Разряд - единицы
            int pos2 = count % 10;

            digit1.ValueDigit(pos1);
            digit2.ValueDigit(pos2);

            // Периодические изменения цвета цифр.
            if (pos1 % 4 == 0) digit1.ColorDigit = digit2.ColorDigit = Brushes.Red;
            else if (pos1 % 3 == 0) digit1.ColorDigit = digit2.ColorDigit = Brushes.Green;
            else if (pos1 % 2 == 0) digit1.ColorDigit = digit2.ColorDigit = Brushes.Black;
            else digit1.ColorDigit = digit2.ColorDigit = Brushes.Blue;

            // Считаем до 100
            // и сброс в начало отсчета.
            count++;
            if (count == 100) count = 0;
        }


        // Обработчик события нажатия на кнопки управления.
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if(sender is Button button)
            {
                string? text = button.Content.ToString();

                switch (text)
                {
                    case "Start":
                        if (dispatcherTimer.IsEnabled == false) dispatcherTimer.Start();
                        else dispatcherTimer.Stop();
                        break;
                    case "Zoom":
                        if (digit1.Width == 80) digit1.Width = digit2.Width = 200;
                        else digit1.Width = digit2.Width = 80;
                        break;
                }
            }
        }
    }
}
